/*Integer Linear Programming for task scheduling problem m|prec|time (Proposed ILP-NOTRAN/REMOVETRAN)*/
/*This is version 1 of the code for the Journal paper on 26 Sep 2012*/



import java.io.*;
import java.lang.Integer;

import packingpackageSHDREDUCED.*;
public class gb
{ 
	
   public static void main(String[] args) throws IOException 
   { 
 
	   String ilp_switch = null;
	   if(args.length>0)
	       ilp_switch=args[0];
	   
	   if(args.length==0 )
	   {
		   helpinterface.helpinterface_method();
		   
	   }
	   
	   else switch(ilp_switch)
	   {
			case "-classic": case "-CLASSIC":
	   			ilpclassic.ilpclassic_method(args.length,args[1],args[2]);
	   			System.out.println("ILP-CLASSIC used");
	   			break;
				
			
	   		case "-classiccompact": case "-CLASSICCOMPACT":
	   			ilpclassiccompact.ilpclassiccompact_method(args.length,args[1],args[2]);
	   			System.out.println("ILP-CLASSIC COMPACT used");
	   			break;	
				
			case "-packingusual": case "-PACKINGUSUAL":
	   			ilppackinggxl.ilppacking_method(args.length,args[1],args[2]);
	   			System.out.println("ILP-PACKING USUAL used");
	   			break;
				
			case "-packingcompact": case "-PACKINGCOMPACT":
	   			ilppackingcompactgxl.ilppackingcompact_method(args.length,args[1],args[2]);
	   			System.out.println("ILP-PACKING COMPACT used");
	   			break;
	   			

				
	   		case "-tc": case "-TC":
	   			ilptcgxl.ilptcgxl_method(args.length,args[1],args[2]);
	   			System.out.println("ILP-TC used");
	   			break;
	   			
	   		case "-rbl": case "-RBL":
	   		    ilprblgxl.ilprblgxl_method(args.length,args[1],args[2]);
	   			System.out.println("ILP-RBL used");
	   			break;
				
	   		case "-shdbasic": case "-SHDBASIC":
	   			shdbasic.ilpcoregxl_method(args.length,args[1],args[2]);
	   			System.out.println("SHD-BASIC used");
	   			break;
	   						
	   			
	   		case "-shdrelaxed": case "-SHDRELAXED":
	   			shdrelaxed.ilpcoregxl_method(args.length,args[1],args[2]);
	   			System.out.println("SHD-RELAXED used");
	   			break;
	   			

	   		case "-shdreduced": case "-SHDREDUCED":
	   			shdreduced.ilpcustomgxl_method(args.length,args[1],args[2]);
	   			System.out.println("SHD-REDUCED used");
	   			break;

	   			
	   		case "-gxlout": case "-GXLOUT":
				int number_of_nodes=gxl_info_in_mem.get_number_of_nodes_method(args[1]);
			    int commcost[][] = new  int[number_of_nodes+2][number_of_nodes+2];
			    commcost=gxl_info_in_mem.get_communication_costs_method(args[1],number_of_nodes);
			   	cplexparse.cplexparse_method(args.length,args[1],args[2],commcost,number_of_nodes);
	   			break;
	
	   		case "-printschedule": case "-PRINTSCHEDULE":
	   			printschedule.printschedule_method(args.length, args[1], args[2]);
	   			//System.out.println("GXLOUT used");
	   			break;
	   			

	   		case "-help": case "-HELP":
	   			helpinterface.helpinterface_method();
	   			//System.out.println("HELP");
	   			break;
	   			
	   		case "-batchprocess": case "-BATCHPROCESS":
	   			//String Strgxlfilenoextension=lpfilenoext.lpfilenoext_method(args[1]);
				String Strgxlfilenoextension=lpfilenoext.lpfilenoext_method_2(args[1]);
	   			cplexscript.cplexscript_method(Strgxlfilenoextension,args[1],args[2]);  
	   			//changecplexlogfile.executeCommand(args[0]);
	   			  break;
				  	  
	   		case "-getgxlschedule": case "-GETGXLSCHEDULE":
	   			getschedulegxl.getschedulegxl_method(args[1]);
				break;
	   			
	   			  
	   			
	   			

	   		default: ilpcoregxl.ilpcoregxl_method(args.length,args[0],args[1]);
	   			     System.out.println("SHD-RELAXED used");
	   			     break;


	   			
	   			
	   			
	   		
	   }	
	   //System.out.println("Number of arguments = "+ args.length);
	  // ilpcoregxl.ilpcoregxl_method(args.length,args[0],args[1]);
	   //commandlinedatatype commandline = new commandlinedatatype(); 
	   //commandline.length = args.length;
	   //commandline.args0=args[0];
	   //commandline.args1=args[1];
	   //int proc=commandline.getcommandlinearg(commandline.length,commandline.args0,commandline.args1);
   }
}